import os
from gcore import Gcore
client = Gcore(
api_key=os.environ.get("GCORE_API_KEY"), # This is the default and can be omitted
)
page = client.waap.analytics.get_detailed_events(
start="2024-04-13T00:00:00+01:00",
)
page = page.results[0]
print(page.id)package main
import (
"context"
"fmt"
"github.com/G-Core/gcore-go"
"github.com/G-Core/gcore-go/option"
"github.com/G-Core/gcore-go/waap"
)
func main() {
client := gcore.NewClient(
option.WithAPIKey("My API Key"),
)
page, err := client.Waap.Analytics.GetDetailedEvents(context.TODO(), waap.AnalyticsGetDetailedEventsParams{
Start: "2024-04-13T00:00:00+01:00",
})
if err != nil {
panic(err.Error())
}
fmt.Printf("%+v\n", page)
}
curl --request GET \
--url https://api.gcore.com/waap/v1/analytics/detailed_events \
--header 'Authorization: <api-key>'const options = {method: 'GET', headers: {Authorization: '<api-key>'}};
fetch('https://api.gcore.com/waap/v1/analytics/detailed_events', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.gcore.com/waap/v1/analytics/detailed_events",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_HTTPHEADER => [
"Authorization: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}HttpResponse<String> response = Unirest.get("https://api.gcore.com/waap/v1/analytics/detailed_events")
.header("Authorization", "<api-key>")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.gcore.com/waap/v1/analytics/detailed_events")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
request["Authorization"] = '<api-key>'
response = http.request(request)
puts response.read_body{
"results": [
{
"id": "96763b8fb655e9f18a2e04097b704e39-458959",
"path": "/new_index",
"method": "GET",
"action": "block",
"rule_id": "86",
"rule_name": "SQL Injection",
"user_agent": {
"full_string": "Mozilla/5.0 (X11; U; Linux x86_64; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/30.1.1599.114 Safari/537.36 Puffin/4.5.0IT",
"client": "Firefox",
"client_version": "44.3",
"base_browser": "Chrome",
"base_browser_version": "47.0.2526.83",
"os": "Android",
"device": "Amazon Kindle Fire HDX 7",
"device_type": "mobile",
"cpu": "intel",
"rendering_engine": "AppleWebKit",
"client_type": "Custom Browser"
},
"network": {
"client_ip": "116.83.107.125",
"country": "IL",
"organization": {
"name": "InfoWeb(Fujitsu Ltd",
"subnet": "116.83.0.0-116.83.127.255"
},
"asn": "15169"
},
"request_time": "2025-08-28T07:13:59",
"reference_id": "ad07c06f19054e484974fa22e9fb6bb1",
"session_id": "0c74d14951b22dc3f22cbba9668ecea1",
"content_type": "text/html; charset=UTF-8",
"scheme": "https",
"http_status_code": 200,
"http_version": "1.1",
"response_time": "3",
"incident_id": "9f06152824394345",
"request_type": "block",
"session_request_count": "1",
"domain": "example.com",
"requested_domain": "example.com",
"query_string": "q=select%20user%20from%20master..a",
"result": "passed",
"traffic_types": [
"sanctioned",
"policy_blocked"
],
"pattern_matched_tags": [
{
"tag": "sql",
"display_name": "SQL Injection",
"description": "This client attempted insertion or “injection” of a SQL query via the input data from the client to the application. A successful SQL injection exploit can read sensitive data from the database, modify database data, etc.",
"field": "uri",
"field_name": "q",
"pattern_name": "SQL Injection Prevention",
"pattern_value": "select user from master..",
"execution_phase": "access"
}
],
"common_tags": [
{
"tag": "injectionattack",
"display_name": "Injection Attack",
"description": "Multiple injection attempts were detected."
}
],
"domain_id": 123,
"policy_override": [
{
"id": 123,
"t": "waf_rule",
"matched": {
"ID861": {
"field": "query_params",
"pattern_found": "SELECT * FROM MASTER"
},
"ID862": {}
}
}
],
"decision": "blocked",
"optional_action": "captcha",
"ja3": "e7d705a3286e19ea42f587b344ee6865",
"ja4": "t13d3113h2_e8f1e7e78f70_ce5650b735ce",
"detector": [
{
"rule_name": "Code Injection Attack Prevention",
"rule_id": "ID842",
"subject_field": "fileName",
"subject_type": "body",
"matched_content": "etc%2Fhttpd"
}
]
}
],
"next": "<string>"
}{
"type": "http-bad-request",
"title": "Bad Request",
"status": 400,
"detail": "Invalid domain name: ''''"
}{
"detail": "Auth token is missing or invalid"
}{
"detail": "Permission denied"
}{
"type": "http-not-found",
"title": "Not Found",
"status": 404,
"detail": "The resource is not found"
}{
"type": "request-validation-failed",
"title": "Request validation error.",
"status": 422,
"detail": "One or more fields have validation errors.",
"errors": [
{
"loc": [
"body",
"name"
],
"detail": "Input should be a valid string"
},
{
"loc": [
"body",
"date"
],
"detail": "Field required"
},
{
"loc": [
"query",
"limit"
],
"detail": "Field required"
}
]
}{
"type": "internal-server-error",
"title": "Internal server error.",
"status": 500,
"detail": "An unexpected condition was encountered which prevented the server from fulfilling the request."
}List security events with request details
Retrieves security events with the same filters, ordering and cursor pagination as Get security events (V2). Each event carries its request details: everything Get request details returns, except the request headers. A page holds up to 1000 events. Requires the analytics_requests permission.
import os
from gcore import Gcore
client = Gcore(
api_key=os.environ.get("GCORE_API_KEY"), # This is the default and can be omitted
)
page = client.waap.analytics.get_detailed_events(
start="2024-04-13T00:00:00+01:00",
)
page = page.results[0]
print(page.id)package main
import (
"context"
"fmt"
"github.com/G-Core/gcore-go"
"github.com/G-Core/gcore-go/option"
"github.com/G-Core/gcore-go/waap"
)
func main() {
client := gcore.NewClient(
option.WithAPIKey("My API Key"),
)
page, err := client.Waap.Analytics.GetDetailedEvents(context.TODO(), waap.AnalyticsGetDetailedEventsParams{
Start: "2024-04-13T00:00:00+01:00",
})
if err != nil {
panic(err.Error())
}
fmt.Printf("%+v\n", page)
}
curl --request GET \
--url https://api.gcore.com/waap/v1/analytics/detailed_events \
--header 'Authorization: <api-key>'const options = {method: 'GET', headers: {Authorization: '<api-key>'}};
fetch('https://api.gcore.com/waap/v1/analytics/detailed_events', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.gcore.com/waap/v1/analytics/detailed_events",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_HTTPHEADER => [
"Authorization: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}HttpResponse<String> response = Unirest.get("https://api.gcore.com/waap/v1/analytics/detailed_events")
.header("Authorization", "<api-key>")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.gcore.com/waap/v1/analytics/detailed_events")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
request["Authorization"] = '<api-key>'
response = http.request(request)
puts response.read_body{
"results": [
{
"id": "96763b8fb655e9f18a2e04097b704e39-458959",
"path": "/new_index",
"method": "GET",
"action": "block",
"rule_id": "86",
"rule_name": "SQL Injection",
"user_agent": {
"full_string": "Mozilla/5.0 (X11; U; Linux x86_64; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/30.1.1599.114 Safari/537.36 Puffin/4.5.0IT",
"client": "Firefox",
"client_version": "44.3",
"base_browser": "Chrome",
"base_browser_version": "47.0.2526.83",
"os": "Android",
"device": "Amazon Kindle Fire HDX 7",
"device_type": "mobile",
"cpu": "intel",
"rendering_engine": "AppleWebKit",
"client_type": "Custom Browser"
},
"network": {
"client_ip": "116.83.107.125",
"country": "IL",
"organization": {
"name": "InfoWeb(Fujitsu Ltd",
"subnet": "116.83.0.0-116.83.127.255"
},
"asn": "15169"
},
"request_time": "2025-08-28T07:13:59",
"reference_id": "ad07c06f19054e484974fa22e9fb6bb1",
"session_id": "0c74d14951b22dc3f22cbba9668ecea1",
"content_type": "text/html; charset=UTF-8",
"scheme": "https",
"http_status_code": 200,
"http_version": "1.1",
"response_time": "3",
"incident_id": "9f06152824394345",
"request_type": "block",
"session_request_count": "1",
"domain": "example.com",
"requested_domain": "example.com",
"query_string": "q=select%20user%20from%20master..a",
"result": "passed",
"traffic_types": [
"sanctioned",
"policy_blocked"
],
"pattern_matched_tags": [
{
"tag": "sql",
"display_name": "SQL Injection",
"description": "This client attempted insertion or “injection” of a SQL query via the input data from the client to the application. A successful SQL injection exploit can read sensitive data from the database, modify database data, etc.",
"field": "uri",
"field_name": "q",
"pattern_name": "SQL Injection Prevention",
"pattern_value": "select user from master..",
"execution_phase": "access"
}
],
"common_tags": [
{
"tag": "injectionattack",
"display_name": "Injection Attack",
"description": "Multiple injection attempts were detected."
}
],
"domain_id": 123,
"policy_override": [
{
"id": 123,
"t": "waf_rule",
"matched": {
"ID861": {
"field": "query_params",
"pattern_found": "SELECT * FROM MASTER"
},
"ID862": {}
}
}
],
"decision": "blocked",
"optional_action": "captcha",
"ja3": "e7d705a3286e19ea42f587b344ee6865",
"ja4": "t13d3113h2_e8f1e7e78f70_ce5650b735ce",
"detector": [
{
"rule_name": "Code Injection Attack Prevention",
"rule_id": "ID842",
"subject_field": "fileName",
"subject_type": "body",
"matched_content": "etc%2Fhttpd"
}
]
}
],
"next": "<string>"
}{
"type": "http-bad-request",
"title": "Bad Request",
"status": 400,
"detail": "Invalid domain name: ''''"
}{
"detail": "Auth token is missing or invalid"
}{
"detail": "Permission denied"
}{
"type": "http-not-found",
"title": "Not Found",
"status": 404,
"detail": "The resource is not found"
}{
"type": "request-validation-failed",
"title": "Request validation error.",
"status": 422,
"detail": "One or more fields have validation errors.",
"errors": [
{
"loc": [
"body",
"name"
],
"detail": "Input should be a valid string"
},
{
"loc": [
"body",
"date"
],
"detail": "Field required"
},
{
"loc": [
"query",
"limit"
],
"detail": "Field required"
}
]
}{
"type": "internal-server-error",
"title": "Internal server error.",
"status": 500,
"detail": "An unexpected condition was encountered which prevented the server from fulfilling the request."
}Authorizations
Query Parameters
Filter by JA3 TLS client fingerprint. Each value must be exactly 32 hexadecimal characters, mixed case allowed, normalized to lowercase. Supply multiple values to match any of them. Omit the parameter to apply no JA3 filter.
10^[0-9a-fA-F]{32}$["e7d705a3286e19ea42f587b344ee6865"]
Filter by JA4 TLS client fingerprint. When present, the value must match the JA4 form <ja4_a>_<ja4_b>_<ja4_c> (a 10-character prefix and two 12-character hexadecimal hashes, mixed case allowed, normalized to lowercase). Supply multiple values to match any of them. Omit the parameter entirely to apply no JA4 filter.
10^[0-9a-zA-Z]{10}_[0-9a-fA-F]{12}_[0-9a-fA-F]{12}$["t13d3113h2_e8f1e7e78f70_ce5650b735ce"]
Exclude entries whose JA3 TLS client fingerprint matches any of the supplied values. Each value must be exactly 32 hexadecimal characters, mixed case allowed, normalized to lowercase. Supply multiple values to exclude any of them. Omit the parameter to apply no JA3 exclusion.
10^[0-9a-fA-F]{32}$["e7d705a3286e19ea42f587b344ee6865"]
Exclude entries whose JA4 TLS client fingerprint equals any of the supplied values. An item must match the JA4 form <ja4_a>_<ja4_b>_<ja4_c> (a 10-character prefix and two 12-character hexadecimal hashes, mixed case allowed, normalized to lowercase). Omit the parameter to apply no JA4 exclusion.
10^[0-9a-zA-Z]{10}_[0-9a-fA-F]{12}_[0-9a-fA-F]{12}$["t13d3113h2_e8f1e7e78f70_ce5650b735ce"]
Include entries that have any of the given traffic types.
A type of traffic that a request is categorized as.
policy_allowed, policy_blocked, custom_rule_allowed, custom_blocked, legit_requests, sanctioned, dynamic, api, static, ajax, redirects, monitor, err_40x, err_50x, passed_to_origin, timeout, other, ddos, legit, monitored ["api", "ajax"]
Response
Successful Response
Page of security events with their request details.
Was this page helpful?